unit Question2_p;

interface

uses
  SysUtils;

type
  TLearner = class
   private
    fname : string;
    feng : integer;
    fmaths : integer;
    faverage : real;
   public
    constructor create (sname : string; ieng, imaths : integer);
    procedure CalcAverage;
    function tostring : string;
    function getname : string;
    function getaverage : real;
    function qualify : boolean;
  end;
implementation

constructor TLearner.create (sname : string; ieng, imaths : integer);
begin
    fname := sname;
    feng := ieng;
    fmaths := imaths;
    faverage := 0;
end;

procedure TLearner.CalcAverage;
begin
  faverage := (feng + fmaths)/2;
end;

function Tlearner.tostring : string;
begin
  result := fname + #9 + inttostr(feng) + #9 + inttostr(fmaths) + #9 + floattostrf(faverage,fffixed,3,1);
end;

function TLearner.getname : string;
begin
  result := fname;
end;

function TLearner.getaverage : real;
begin
  result := faverage;
end;
    
function TLearner.qualify : boolean;
begin
  if faverage >= 60 then
    qualify := true
  else
    qualify := false;
end;




end.
 