unit Question2_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ComCtrls, Subjects_u;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    RichEdit1: TRichEdit;
    Options1: TMenuItem;
    Average1: TMenuItem;
    ITPhysicalScienceMaths1: TMenuItem;
    SearchforaLearner1: TMenuItem;
    Exit1: TMenuItem;
    procedure FormActivate(Sender: TObject);
    procedure Average1Click(Sender: TObject);
    procedure ITPhysicalScienceMaths1Click(Sender: TObject);
    procedure SearchforaLearner1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  icount : integer;
  arrLearners : array[1..50] of TLearner;
implementation

{$R *.dfm}

procedure TForm1.FormActivate(Sender: TObject);
var
  myfile : textfile;
  soneline : string;
  ipos, ieng, imaths : integer;
  sname : string;
begin
  if fileexists('Learner.txt') <> true then
    begin
      ShowMessage('File does not exist');
      Exit;
    end;
  Assignfile(myfile, 'Learner.txt');
  Reset(myfile);
  icount := 0;
  while not eof(myfile) do
    begin
      readln(myfile,soneline);
      inc(icount);
      ipos := pos(',',soneline);
      sname := copy(soneline, 1, ipos - 1);
      delete(soneline, 1, ipos);
      ipos := pos(',',soneline);
      ieng := strtoint(copy(soneline, 1, ipos - 1));
      delete(soneline, 1, ipos);
      imaths := strtoint(soneline);
      arrLearners[icount] := TLearner.create(sname, ieng, imaths);
    end;
  closefile(myfile);
end;


procedure TForm1.Average1Click(Sender: TObject);
var
  k : integer;
begin
  richedit1.lines.add('Name' + #9 + #9 + 'Average');
  for k := 1 to icount do
   begin
    arrLearners[k].CalcAverage;
    richedit1.Lines.add(arrLearners[k].getname + #9 + floattostrf(arrLearners[k].getaverage,fffixed,6,0));
   end;
end;

procedure TForm1.ITPhysicalScienceMaths1Click(Sender: TObject);
var
  k : integer;
begin
  richedit1.lines.add('Name' + #9 +#9+ 'English' + #9 + 'Maths' + #9 + 'Average');
  for k := 1 to icount do
    begin
      arrLearners[k].CalcAverage;
      if arrlearners[k].qualify then
        richedit1.Lines.Add(arrlearners[k].tostring);
    end;
end;

procedure TForm1.SearchforaLearner1Click(Sender: TObject);
var
  sinput : string;
  k : integer;
  bfound : boolean;
begin
  sinput := inputbox('Enter Name','','');
  bfound := false;
  k := 1;
  while (k <= icount) and (bfound = false) do
    begin
      if arrLearners[k].getname = sinput then
        bfound := true
      else
        bfound := false;
      inc(k);
    end;
    if bfound = true then
      ShowMessage(sinput + ' found.');
    if bfound = false then
      ShowMessage(sinput + ' not found.');
end;

end.


