unit question3_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
//    procedure Calculate;
    procedure CalculateTotals;
    procedure CalculateAvgWeek;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  irow, icol : integer;
begin
  randomize;
  for icol := 1 to 4 do
    for irow := 1 to 7 do
      stringgrid1.Cells[icol,irow] := inttostr(random(500)+101);

  for icol := 1 to 4 do
    stringgrid1.Cells[icol,0] := 'Week '+inttostr(icol);

  for irow := 1 to 7 do
    stringgrid1.cells[0,irow] := 'Class '+inttostr(irow);

end;

procedure TForm1.CalculateTotals;
var
  icol,irow, itotal : integer;
begin
  stringgrid1.cells[0,8] := 'Totals';
  for icol := 1 to 4 do
    begin
    itotal := 0;
      for irow := 1 to 7 do
        begin
          itotal := itotal + strtoint(stringgrid1.cells[icol,irow]);
        end;
      stringgrid1.Cells[icol,irow] := inttostr(itotal)
    end;
end;

procedure TForm1.CalculateAvgWeek;
var
  irow, icol : integer;
  rtotal, raverage : real;
begin
  stringgrid1.cells[0,9] := 'Average';
  for icol := 1 to 4 do
    begin
       rtotal := rtotal + strtofloat(stringgrid1.cells[icol,8]);
       raverage := rtotal/7;
       stringgrid1.cells[icol,9] := floattostrf(raverage,fffixed,6,2);
       rtotal := 0;
    end;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  CalculateTotals;
  CalculateAvgWeek;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  irow, ihigh, iclass, icol, isum,k,l,itemp : integer;
  arrclass : array[1..7] of integer;
begin
  ihigh := 0;
  for irow := 1 to 7 do
    begin
      isum := 0;
      for icol := 1 to 4 do
        begin
        isum := isum + strtoint(stringgrid1.cells[icol,irow]);
        end;
        if isum > ihigh then
         begin
          ihigh := isum;
          iclass := irow;
         end;

{      arrclass[irow] := isum;}
    end;
{  for k := 1 to 6 do
    for l := k+1 to 7 do
      begin
        if arrclass[k] < arrclass[l] then
          begin
            itemp := arrclass[k];
            arrclass[k] := arrclass[l];
            arrclass[l] := itemp;
          end;
      end;}
  ShowMessage('Winning class: '+inttostr(iclass));
end;

end.
